/* mna5r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer iter;
} mna5rr_;

#define mna5rr_1 mna5rr_

/* Subroutine */ int mna5r_c(R_fp f, integer *n, real *p, integer *mp, real *y,
         real *pr, real *prr, real *pbar, real *eps, integer *iregim,
         integer *iflag, integer *itmax)
{
    /* Initialized data */

    static real alpha = 1.f;
    static real beta = .5f;
    static real gamma = 2.f;
    static real zero = 0.f;
    static real one = 1.f;
    static real half = .5f;
    static real two = 2.f;

    /* System generated locals */
    integer p_dim1, p_offset, i__1, i__2;
    real r__1;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static integer inhi;
    static real rtol;
    static integer mpts;
    static real yprr;
    static integer i__, j, l;
    static real s1, s2;
    static integer ihi, ilo;
    static real ypr;

#define p_ref(a_1,a_2) p[(a_2)*p_dim1 + a_1]

    /* Parameter adjustments */
    --pbar;
    --prr;
    --pr;
    --y;
    p_dim1 = *mp;
    p_offset = 1 + p_dim1 * 1;
    p -= p_offset;

    /* Function Body */
    *iflag = 0;
    mna5rr_1.iter = 0;
    mpts = *n + 1;
    if (*iregim != 0) {
        goto L20;
    }
    s1 = ((real)sqrt((real)(one + *n)) + *n - one) / (*n * (real)sqrt(two));
    s2 = ((real)sqrt((real)(one + *n)) - one) / (*n * (real)sqrt(two));
    i__1 = mpts;
    for (i__ = 2; i__ <= i__1; ++i__) {
        i__2 = *n;
        for (j = 1; j <= i__2; ++j) {
            p_ref(i__, j) = s2 + p_ref(1, j);
            l = i__ - 1;
            p_ref(i__, l) = s1 + p_ref(1, j);
/* L10: */
        }
    }
L20:
    i__2 = mpts;
    for (i__ = 1; i__ <= i__2; ++i__) {
        i__1 = *n;
        for (j = 1; j <= i__1; ++j) {
            pr[j] = p_ref(i__, j);
/* L30: */
        }
        y[i__] = (real)(*f)(&pr[1], n);
/* L40: */
    }
L50:
    ilo = 1;
    if (y[1] <= y[2]) {
        goto L60;
    }
    ihi = 1;
    inhi = 2;
    goto L70;
L60:
    ihi = 2;
    inhi = 1;
L70:
    i__2 = mpts;
    for (i__ = 1; i__ <= i__2; ++i__) {
        if (y[i__] < y[ilo]) {
            ilo = i__;
        }
        if (y[i__] <= y[ihi]) {
            goto L80;
        }
        inhi = ihi;
        ihi = i__;
        goto L90;
L80:
        if (y[i__] <= y[inhi]) {
            goto L90;
        }
        if (i__ != ihi) {
            inhi = i__;
        }
L90:
        ;
    }
    rtol = (r__1 = y[ihi] - y[ilo], abs(r__1));
    if (rtol < abs(*eps)) {
        goto L280;
    }
    if (mna5rr_1.iter == *itmax) {
        goto L290;
    }
    ++mna5rr_1.iter;
    i__2 = *n;
    for (j = 1; j <= i__2; ++j) {
        pbar[j] = zero;
/* L100: */
    }
    i__2 = mpts;
    for (i__ = 1; i__ <= i__2; ++i__) {
        if (i__ == ihi) {
            goto L120;
        }
        i__1 = *n;
        for (j = 1; j <= i__1; ++j) {
            pbar[j] += p_ref(i__, j);
/* L110: */
        }
L120:
        ;
    }
    i__2 = *n;
    for (j = 1; j <= i__2; ++j) {
        pbar[j] /= *n;
        pr[j] = (one + alpha) * pbar[j] - alpha * p_ref(ihi, j);
/* L130: */
    }
    ypr = (real)(*f)(&pr[1], n);
    if (ypr > y[ilo]) {
        goto L180;
    }
    i__2 = *n;
    for (j = 1; j <= i__2; ++j) {
        prr[j] = gamma * pr[j] + (one - gamma) * pbar[j];
/* L140: */
    }
    yprr = (real)(*f)(&prr[1], n);
    if (yprr >= y[ilo]) {
        goto L160;
    }
    i__2 = *n;
    for (j = 1; j <= i__2; ++j) {
        p_ref(ihi, j) = prr[j];
/* L150: */
    }
    y[ihi] = yprr;
    goto L50;
L160:
    i__2 = *n;
    for (j = 1; j <= i__2; ++j) {
        p_ref(ihi, j) = pr[j];
/* L170: */
    }
    y[ihi] = ypr;
    goto L50;
L180:
    if (ypr < y[inhi]) {
        goto L260;
    }
    if (ypr >= y[ihi]) {
        goto L200;
    }
    i__2 = *n;
    for (j = 1; j <= i__2; ++j) {
        p_ref(ihi, j) = pr[j];
/* L190: */
    }
    y[ihi] = ypr;
L200:
    i__2 = *n;
    for (j = 1; j <= i__2; ++j) {
        prr[j] = beta * p_ref(ihi, j) + (one - beta) * pbar[j];
/* L210: */
    }
    yprr = (real)(*f)(&prr[1], n);
    if (yprr >= y[ihi]) {
        goto L230;
    }
    i__2 = *n;
    for (j = 1; j <= i__2; ++j) {
        p_ref(ihi, j) = prr[j];
/* L220: */
    }
    y[ihi] = yprr;
    goto L50;
L230:
    i__2 = mpts;
    for (i__ = 1; i__ <= i__2; ++i__) {
        if (i__ == ilo) {
            goto L250;
        }
        i__1 = *n;
        for (j = 1; j <= i__1; ++j) {
            pr[j] = half * (p_ref(i__, j) + p_ref(ilo, j));
            p_ref(i__, j) = pr[j];
/* L240: */
        }
        y[i__] = (real)(*f)(&pr[1], n);
L250:
        ;
    }
    goto L50;
L260:
    i__2 = *n;
    for (j = 1; j <= i__2; ++j) {
        p_ref(ihi, j) = pr[j];
/* L270: */
    }
    y[ihi] = ypr;
    goto L50;
L280:
    *iflag = 1;
L290:
    return 0;
} /* mna5r_c */

#undef p_ref
